import java.awt.*;

public class Matem //   
     {
      public double Rast(Comp A, Comp B, Comp C) //       ,   
           {
            double x1=A.Re; // 1-  
            double y1=A.Im; 
            double x2=B.Re; // 2-  
            double y2=B.Im;
            double x3=C.Re; //     
            double y3=C.Im;
            double x; //    (  )
            double y;
            double t; //  
            // 
            t=-((x1-x2)*(x1-x3)+(y1-y2)*(y1-y3))/((x1-x2)*(x1-x2)+(y1-y2)*(y1-y2));
            x=x1+(x1-x2)*t;
            y=y1+(y1-y2)*t;
            return Math.sqrt((x-x3)*(x-x3)+(y-y3)*(y-y3)); //      
           }

     public double d(Comp A, Comp B)  //       
           {
            return Math.sqrt((A.Re-B.Re)*(A.Re-B.Re)+(A.Im-B.Im)*(A.Im-B.Im));
           }

     public double RastOkr(Comp C, double R, Comp A) //     A   (C - , R - )
           {
            return Math.abs(d(A,C)-R);
           }

      // A*x2+B*x+C=0
      public double[] SqrUrav(double A, double B, double C) //    
           {
            double Diskr = B*B-4*A*C; // 
            double[] resh = new double[2];
            if ((Diskr>=0) && (A!=0)) //    ( )    
              {
               resh[0]=(-B+Math.sqrt(Diskr))/(2*A);
               resh[1]=(-B-Math.sqrt(Diskr))/(2*A);
               return resh; //       double[2]
              }
            else
              {
               resh[0]=Double.NaN; //      
               resh[1]=Double.NaN; //    
               return resh;
              }
           }

      public Comp HardRelation(Point U, Point V, Point S, Point T) //  
           {
           int USx = U.x - S.x;
           int USy = U.y - S.y;
           int UTx = U.x - T.x;
           int UTy = U.y - T.y;
           int VSx = V.x - S.x;
           int VSy = V.y - S.y;
           int VTx = V.x - T.x;
           int VTy = V.y - T.y;
           double A = USx*VTx-USy*VTy;
           double B = USx*VTy+USy*VTx;
           double C = UTx*VSx-UTy*VSy;
           double D = UTx*VSy+UTy*VSx;
           Comp resh = new Comp();
           resh.Re = (A*C+B*D)/(C*C+D*D);
           resh.Im = (B*C-A*D)/(C*C+D*D);
           return resh;
           }

     public double Arg(Point U) //   
           {
            double fi = 0;
            double a = U.x;
            double b = U.y;
            if (U.x>0) fi=Math.atan(b/a);
            if ( (U.x==0) && (U.y>0) ) fi=Math.PI/2;
            if (U.x<0) fi=Math.PI+Math.atan(b/a);
            if ( (U.x==0) && (U.y<0) ) fi=-Math.PI/2;
            return fi;
           }

     public Comp DLCircle( Comp z ) //   Im.z>0   |w|<1
           // z=x+iy
           // w=(z-i)/(z+i)
           {            
            Comp w = new Comp();
            double znam = z.Re*z.Re+(z.Im+1)*(z.Im+1);
            w.Re = (z.Re*z.Re+z.Im*z.Im-1)/znam;
            w.Im = -2*z.Re/znam;
            return w;
           }

     public Comp DLField( Comp w ) //   |w|<1   Im.z>0
           // w=x+iy
           // z=i(w+1)/(1-w)
           {            
            Comp z = new Comp();
            double znam = w.Im*w.Im+(w.Re-1)*(w.Re-1);
            z.Im = -(w.Re*w.Re+w.Im*w.Im-1)/znam;
            z.Re = -2*w.Im/znam;
            return z;
           }

     public double l(double c, Comp U, Comp V, Comp S, Comp T) //  
           // l(u,v)=c|ln(u,v,s,t)|
           {
           double USx = U.Re - S.Re;
           double USy = U.Im - S.Im;
           double UTx = U.Re - T.Re;
           double UTy = U.Im - T.Im;
           double VSx = V.Re - S.Re;
           double VSy = V.Im - S.Im;
           double VTx = V.Re - T.Re;
           double VTy = V.Im - T.Im;
           double A = USx*VTx-USy*VTy;
           double B = USx*VTy+USy*VTx;
           double C = UTx*VSx-UTy*VSy;
           double D = UTx*VSy+UTy*VSx;
           Comp Hard = new Comp();
           Hard.Re = (A*C+B*D)/(C*C+D*D);
           Hard.Im = (B*C-A*D)/(C*C+D*D); //      S,T  
           return c*Math.abs(Math.log(Hard.Re));
           }

     public Comp inv(Comp M, Comp O, double R) //            R
           {
            return new Comp(O.Re+R*R*(M.Re-O.Re)/((M.Re-O.Re)*(M.Re-O.Re)+(M.Im-O.Im)*(M.Im-O.Im)),O.Im+R*R*(M.Im-O.Im)/((M.Re-O.Re)*(M.Re-O.Re)+(M.Im-O.Im)*(M.Im-O.Im)));
           }

     public Comp sim(Comp M, Comp A, Comp B) //       
           {
            double t=((A.Re-B.Re)*(A.Re-M.Re)+(A.Im-B.Im)*(A.Im-M.Im))/((B.Re-A.Re)*(B.Re-A.Re)+(B.Im-A.Im)*(B.Im-A.Im));
            Comp T = new Comp(A.Re+(B.Re-A.Re)*t,A.Im+(B.Im-A.Im)*t);
            return new Comp(2*T.Re-M.Re,2*T.Im-M.Im);
           }
  }      