public class Peresechenie
      {
       Comp P1,P2;
       boolean peresek1, peresek2;
       Comp A1, B1, A2, B2;
       Comp O1, O2;
       double R1, R2;
       boolean Circle1, Circle2;
       double toch=0.0000001;
       public void OtrezokSOtrezok(Comp a1, Comp b1, Comp a2, Comp b2)
             {
              A1 = new Comp(a1.Re,a1.Im);
              A2 = new Comp(a2.Re,a2.Im);
              B1 = new Comp(b1.Re,b1.Im);
              B2 = new Comp(b2.Re,b2.Im);
              Comp L = new Comp(B1.Re-A1.Re,B1.Im-A1.Im);
              Comp M = new Comp(B2.Re-A2.Re,B2.Im-A2.Im);
              if (Math.abs(M.Im*L.Re-M.Re*L.Im)<toch)
                peresek1=false;
              else
                {
                 double t = (L.Im*(A2.Re-A1.Re)-L.Re*(A2.Im-A1.Im))/(M.Im*L.Re-M.Re*L.Im);
                 P1 = new Comp(A2.Re+M.Re*t,A2.Im+M.Im*t);
                 Comp S1 = new Comp((A1.Re+B1.Re)/2,(A1.Im+B1.Im)/2);
                 Comp S2 = new Comp((A2.Re+B2.Re)/2,(A2.Im+B2.Im)/2);
                 if ((Z1(P1)==Z1(S1)) && (Z2(P1)==Z2(S1)) && (Z3(P1)==Z3(S2)) && (Z4(P1)==Z4(S2)))
                   peresek1=true;
                 else
                   peresek1=false;
                }
             }

       public void OtrezokSDuga(Comp a1, Comp b1, Comp a2, Comp b2, Comp o2, double r2, boolean circle2)
             {
              A1 = new Comp(a1.Re,a1.Im);
              A2 = new Comp(a2.Re,a2.Im);
              B1 = new Comp(b1.Re,b1.Im);
              B2 = new Comp(b2.Re,b2.Im);
              O2 = new Comp (o2.Re,o2.Im);
              R2 = r2;
              Circle2 = circle2;
              Comp L = new Comp(B1.Re-A1.Re,B1.Im-A1.Im);
              Comp S1 = new Comp((A1.Re+B1.Re)/2,(A1.Im+B1.Im)/2);
              Comp S2 = new Comp((A2.Re+B2.Re)/2,(A2.Im+B2.Im)/2);
              Matem mat = new Matem();
              double t1 = mat.SqrUrav(L.Re*L.Re+L.Im*L.Im,2*(L.Re*(A1.Re-O2.Re)+L.Im*(A1.Im-O2.Im)),(A1.Re-O2.Re)*(A1.Re-O2.Re)+(A1.Im-O2.Im)*(A1.Im-O2.Im)-R2*R2)[0];
              double t2 = mat.SqrUrav(L.Re*L.Re+L.Im*L.Im,2*(L.Re*(A1.Re-O2.Re)+L.Im*(A1.Im-O2.Im)),(A1.Re-O2.Re)*(A1.Re-O2.Re)+(A1.Im-O2.Im)*(A1.Im-O2.Im)-R2*R2)[1];
              if ((t1==Double.NaN) && (t2==Double.NaN))
                {
                 peresek1=false;
                 peresek2=false;
                }
              else
                {
                 P1 = new Comp(A1.Re+L.Re*t1,A1.Im+L.Im*t1);
                 P2 = new Comp(A1.Re+L.Re*t2,A1.Im+L.Im*t2);
                 boolean per1 = false;
                 boolean per2 = false;
                 if ((Z1(P1)==Z1(S1)) && (Z2(P1)==Z2(S1))) per1=true;
                 if ((Z1(P2)==Z1(S1)) && (Z2(P2)==Z2(S1))) per2=true;
                 if (!Circle2)
                   {
                    if ((Z5(P1)==Z5(S2)) && (Z6(P1)==Z6(S2))) 
                      peresek1=per1;
                    else
                      peresek1=false;
                    if ((Z5(P2)==Z5(S2)) && (Z6(P2)==Z6(S2))) 
                      peresek2=per2;
                    else
                      peresek2=false;
                   }
                 else
                   {
                    peresek1 = per1;
                    peresek2 = per2;
                   }
                }
             }

       public void DugaSDuga(Comp a1, Comp b1, Comp o1, double r1, boolean circle1, Comp a2, Comp b2, Comp o2, double r2, boolean circle2)
             {
              A1 = new Comp(a1.Re,a1.Im);
              A2 = new Comp(a2.Re,a2.Im);
              B1 = new Comp(b1.Re,b1.Im);
              B2 = new Comp(b2.Re,b2.Im);
              O1 = new Comp (o1.Re,o1.Im);
              O2 = new Comp (o2.Re,o2.Im);
              R1 = r1;
              R2 = r2;
              Circle1 = circle1;
              Circle2 = circle2;
              Comp S1 = new Comp((A1.Re+B1.Re)/2,(A1.Im+B1.Im)/2);
              Comp S2 = new Comp((A2.Re+B2.Re)/2,(A2.Im+B2.Im)/2);
              Matem mat = new Matem();
              if ((mat.d(O1,O2)>R1+R2) || (mat.d(O1,O2)<Math.max(R1,R2)-Math.min(R1,R2)) || ( (Math.abs(O1.Re-O2.Re)<toch) && (Math.abs(O1.Im-O2.Im)<toch) && (Math.abs(R1-R2)<toch)))
                {
                 peresek1=false;
                 peresek2=false;
                }
              else
                {
                 if (Math.abs(O1.Re-O2.Re)>toch)
                   {
                    double K1 = (R1*R1-R2*R2+O2.Re*O2.Re-O1.Re*O1.Re+O2.Im*O2.Im-O1.Im*O1.Im)/(2*(O2.Re-O1.Re));
                    double K2 = (O1.Im-O2.Im)/(O2.Re-O1.Re);
                    double Y1 = mat.SqrUrav(K2*K2+1,2*K2*(K1-O1.Re)-2*O1.Im,(K1-O1.Re)*(K1-O1.Re)+O1.Im*O1.Im-R1*R1)[0];
                    double Y2 = mat.SqrUrav(K2*K2+1,2*K2*(K1-O1.Re)-2*O1.Im,(K1-O1.Re)*(K1-O1.Re)+O1.Im*O1.Im-R1*R1)[1];
                    double X11 = O1.Re+Math.sqrt(R1*R1-(Y1-O1.Im)*(Y1-O1.Im));
                    double X12 = O1.Re+Math.sqrt(R1*R1-(Y2-O1.Im)*(Y2-O1.Im));
                    double X21 = O1.Re-Math.sqrt(R1*R1-(Y1-O1.Im)*(Y1-O1.Im));
                    double X22 = O1.Re-Math.sqrt(R1*R1-(Y2-O1.Im)*(Y2-O1.Im));
                    Comp ot1 = new Comp(X11,Y1);
                    Comp ot2 = new Comp(X21,Y1);
                    Comp ot3 = new Comp(X12,Y2);
                    Comp ot4 = new Comp(X22,Y2);
                    if (Math.abs((ot1.Re-O2.Re)*(ot1.Re-O2.Re)+(ot1.Im-O2.Im)*(ot1.Im-O2.Im)-R2*R2)<Math.abs((ot2.Re-O2.Re)*(ot2.Re-O2.Re)+(ot2.Im-O2.Im)*(ot2.Im-O2.Im)-R2*R2))
                      P1 = new Comp(ot1.Re,ot1.Im);
                    else
                      P1 = new Comp(ot2.Re,ot2.Im);
                    if (Math.abs((ot3.Re-O2.Re)*(ot3.Re-O2.Re)+(ot3.Im-O2.Im)*(ot3.Im-O2.Im)-R2*R2)<Math.abs((ot4.Re-O2.Re)*(ot4.Re-O2.Re)+(ot4.Im-O2.Im)*(ot4.Im-O2.Im)-R2*R2))
                      P2 = new Comp(ot3.Re,ot3.Im);
                    else
                      P2 = new Comp(ot4.Re,ot4.Im);
                   }
                 else
                   {
                    double Y3 = (R1*R1-R2*R2+O2.Im*O2.Im-O1.Im*O1.Im)/(2*(O2.Im-O1.Im));
                    double X31 = O1.Re+Math.sqrt(R1*R1-(Y3-O1.Im)*(Y3-O1.Im));
                    double X32 = O1.Re-Math.sqrt(R1*R1-(Y3-O1.Im)*(Y3-O1.Im));
                    P1 = new Comp(X31,Y3);
                    P2 = new Comp(X32,Y3);
                   }
                 boolean per1 = false;
                 boolean per2 = false;
                 if ((Circle1) && (Circle2))
                   {
                    peresek1=true;
                    peresek2=true;
                   }
                 if ((!Circle1) && (Circle2))
                   {
                    if ((Z7(P1)==Z7(S1)) && (Z8(P1)==Z8(S1))) 
                      peresek1=true;
                    else
                      peresek1=false;
                    if ((Z7(P2)==Z7(S1)) && (Z8(P2)==Z8(S1))) 
                      peresek2=true;
                    else
                      peresek2=false;
                   }
                 if ((Circle1) && (!Circle2))
                   {
                    if ((Z5(P1)==Z5(S2)) && (Z6(P1)==Z6(S2))) 
                      peresek1=true;
                    else
                      peresek1=false;
                    if ((Z5(P2)==Z5(S2)) && (Z6(P2)==Z6(S2))) 
                      peresek2=true;
                    else
                      peresek2=false;
                   }
                 if ((!Circle1) && (!Circle2))
                   {
                    if ((Z7(P1)==Z7(S1)) && (Z8(P1)==Z8(S1))) 
                      per1=true;
                    else
                      per1=false;
                    if ((Z7(P2)==Z7(S1)) && (Z8(P2)==Z8(S1))) 
                      per2=true;
                    else
                      per2=false;
                    if ((Z5(P1)==Z5(S2)) && (Z6(P1)==Z6(S2))) 
                      peresek1=per1;
                    else
                      peresek1=false;
                    if ((Z5(P2)==Z5(S2)) && (Z6(P2)==Z6(S2))) 
                      peresek2=per2;
                    else
                      peresek2=false; 
                   }
                }                 
             }

       private boolean Z1(Comp P)
              {
               boolean z1=false;
               if ((P.Re-A1.Re)*(A1.Re-B1.Re)-(B1.Im-A1.Im)*(P.Im-A1.Im)>=0)
                 z1=true;
               else
                 z1=false;
               return z1;
              }
       private boolean Z2(Comp P)
              {
               boolean z2=false;
               if ((P.Re-B1.Re)*(A1.Re-B1.Re)-(B1.Im-A1.Im)*(P.Im-B1.Im)>=0)
                 z2=true;
               else
                 z2=false;
               return z2;
              }
       private boolean Z3(Comp P)
              {
               boolean z3=false;
               if ((P.Re-A2.Re)*(A2.Re-B2.Re)-(B2.Im-A2.Im)*(P.Im-A2.Im)>=0)
                 z3=true;
               else
                 z3=false;
               return z3;
              }
       private boolean Z4(Comp P)
              {
               boolean z4=false;
               if ((P.Re-B2.Re)*(A2.Re-B2.Re)-(B2.Im-A2.Im)*(P.Im-B2.Im)>=0)
                 z4=true;
               else
                 z4=false;
               return z4;
              }
       private boolean Z5(Comp P)
              {
               boolean z5=false;
               if ((P.Re-A2.Re)*(O2.Im-A2.Im)-(O2.Re-A2.Re)*(P.Im-A2.Im)>=0)
                 z5=true;
               else
                 z5=false;
               return z5;
              }
       private boolean Z6(Comp P)
              {
               boolean z6=false;
               if ((P.Re-B2.Re)*(O2.Im-B2.Im)-(O2.Re-B2.Re)*(P.Im-B2.Im)>=0)
                 z6=true;
               else
                 z6=false;
               return z6;
              }
       private boolean Z7(Comp P)
              {
               boolean z7=false;
               if ((P.Re-A1.Re)*(O1.Im-A1.Im)-(O1.Re-A1.Re)*(P.Im-A1.Im)>=0)
                 z7=true;
               else
                 z7=false;
               return z7;
              }
       private boolean Z8(Comp P)
              {
               boolean z8=false;
               if ((P.Re-B1.Re)*(O1.Im-B1.Im)-(O1.Re-B1.Re)*(P.Im-B1.Im)>=0)
                 z8=true;
               else
                 z8=false;
               return z8;
              }

      }